Index: issm/trunk/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Element.cpp	(revision 26744)
@@ -2273,10 +2402,10 @@
 	GetInputListOnVertices(&sl[0],SealevelEnum);
 	GetInputListOnVertices(&phi[0],MaskOceanLevelsetEnum);
-	rho_water   = FindParam(MaterialsRhoSeawaterEnum);
-	rho_ice     = FindParam(MaterialsRhoIceEnum);
-	density     = rho_ice/rho_water;
+	IssmDouble rho_water   = FindParam(MaterialsRhoSeawaterEnum);
+	IssmDouble rho_ice     = FindParam(MaterialsRhoIceEnum);
+	IssmDouble density     = rho_ice/rho_water;
 
 	/*go through vertices, and update inputs, considering them to be TriaVertex type: */
-	for(i=0;i<NUM_VERTICES;i++){
+	for(int i=0;i<NUM_VERTICES;i++){
 		/* Contact FS*/
 		if(migration_style == ContactEnum){
@@ -2284,6 +2413,8 @@
 			if(phi[i]>=0.) b[i]=r[i];
 		}
-		else if(migration_style == GroundingOnlyEnum && b[i]<r[i]) b[i]=r[i];
-		/*Ice shelf: if bed below bathymetry, impose it at the bathymetry and update surface, elso do nothing */
+		else if(migration_style == GroundingOnlyEnum && b[i]<r[i]){
+			/*Ice shelf: if bed below bathymetry, impose it at the bathymetry and update surface, elso do nothing */
+			b[i]=r[i];
+		}
 		else if(phi[i]<=0.){
 			if(b[i]<=r[i]){
@@ -2299,10 +2430,10 @@
 				/*Unground only if the element is connected to the ice shelf*/
 				if(migration_style==AggressiveMigrationEnum || migration_style==SubelementMigrationEnum){
-					s[i]        = (1-density)*h[i]+sl[i];
-					b[i]        = -density*h[i]+sl[i];
+					s[i] = (1.-density)*h[i]+sl[i];
+					b[i] = -density*h[i]+sl[i];
 				}
 				else if(migration_style==SoftMigrationEnum && phi_ungrounding[vertices[i]->Pid()]<0.){
-					s[i]        = (1-density)*h[i]+sl[i];
-					b[i]        = -density*h[i]+sl[i];
+					s[i] = (1.-density)*h[i]+sl[i];
+					b[i] = -density*h[i]+sl[i];
 				}
 				else{
@@ -2314,5 +2445,5 @@
 
 	/*Recalculate phi*/
-	for(i=0;i<NUM_VERTICES;i++){
+	for(int i=0;i<NUM_VERTICES;i++){
 		if(migration_style==SoftMigrationEnum){
 			bed_hydro=-density*h[i]+sl[i];
@@ -2321,5 +2452,7 @@
 			}
 		}
-		else if(migration_style!=ContactEnum) phi[i]=h[i]+(r[i]-sl[i])/density;
+		else if(migration_style!=ContactEnum){
+			phi[i]=h[i]+(r[i]-sl[i])/density;
+		}
 		else{
 			/*do nothing*/
@@ -2332,15 +2465,5 @@
 	this->AddInput(BaseEnum,&b[0],P1Enum);
 
-	/*Delete*/
-	xDelete<IssmDouble>(melting);
-	xDelete<IssmDouble>(phi);
-	xDelete<IssmDouble>(r);
-	xDelete<IssmDouble>(b);
-	xDelete<IssmDouble>(s);
-	xDelete<IssmDouble>(sl);
-	xDelete<IssmDouble>(h);
-
-}
-/*}}}*/
+}/*}}}*/
 void       Element::MismipFloatingiceMeltingRate(){/*{{{*/
 
@@ -2518,5 +2641,5 @@
 void       Element::PicoUpdateBoxid(int* max_boxid_basin_list){/*{{{*/
 
-	if(!this->IsIceInElement() || !this->IsFloating()) return;
+	if(!this->IsIceInElement() || !this->IsAllFloating()) return;
 
 	int        basin_id;
@@ -2559,5 +2682,5 @@
 void       Element::PicoUpdateBox(int loopboxid){/*{{{*/
 
-	if(!this->IsIceInElement() || !this->IsFloating()) return;
+	if(!this->IsIceInElement() || !this->IsAllFloating()) return;
 
 	int boxid;
@@ -2566,5 +2689,4 @@
 
 	const int NUM_VERTICES = this->GetNumberOfVertices();
-
 	int        basinid, maxbox, num_basins, numnodes, M;
 	IssmDouble gamma_T, overturning_coeff, thickness;
@@ -2593,6 +2715,7 @@
 	this->GetInputValue(&basinid,BasalforcingsPicoBasinIdEnum);
 	this->parameters->FindParam(&isplume, BasalforcingsPicoIsplumeEnum);
-	Input *thickness_input    = this->GetInput(ThicknessEnum);                         _assert_(thickness_input);
-	_assert_(basinid<=num_basins);
+	Input *thickness_input = this->GetInput(ThicknessEnum); 
+   _assert_(basinid<=num_basins);
+   _assert_(thickness_input);
 
 	IssmDouble* boxareas = NULL;
@@ -2603,8 +2726,8 @@
 	IssmDouble g1               = area_boxi*gamma_T;
 
-	IssmDouble* basalmeltrates_shelf 				= xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* potential_pressure_melting_point	= xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* Tocs 								= xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* Socs								= xNew<IssmDouble>(NUM_VERTICES);
+	IssmDouble basalmeltrates_shelf[MAXVERTICES];
+	IssmDouble potential_pressure_melting_point[MAXVERTICES];
+	IssmDouble Tocs[MAXVERTICES];
+	IssmDouble Socs[MAXVERTICES];
 
 	/* First box calculations */
@@ -2612,9 +2735,9 @@
 		/* Get box1 parameters and inputs */
 		IssmDouble time, toc_farocean, soc_farocean;
+      IssmDouble overturnings[MAXVERTICES];
 		this->parameters->FindParam(&time,TimeEnum);
 		this->parameters->FindParam(&toc_farocean, basinid, time, BasalforcingsPicoFarOceantemperatureEnum);
 		this->parameters->FindParam(&soc_farocean, basinid, time, BasalforcingsPicoFarOceansalinityEnum);
-		IssmDouble 	s1 				= soc_farocean/(nu*lambda);
-		IssmDouble* overturnings 	= xNew<IssmDouble>(NUM_VERTICES);
+		IssmDouble s1 = soc_farocean/(nu*lambda);
 		Input *overturningC_input = this->GetInput(BasalforcingsPicoOverturningCoeffEnum); _assert_(overturningC_input);
 
@@ -2640,8 +2763,8 @@
 		}
 
-		if(!isplume) this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,basalmeltrates_shelf,P1DGEnum);
-		this->AddInput(BasalforcingsPicoSubShelfOceanTempEnum,Tocs,P1DGEnum);
-		this->AddInput(BasalforcingsPicoSubShelfOceanSalinityEnum,Socs,P1DGEnum);
-		this->AddInput(BasalforcingsPicoSubShelfOceanOverturningEnum,overturnings,P1DGEnum);
+		if(!isplume) this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,&basalmeltrates_shelf[0],P1DGEnum);
+		this->AddInput(BasalforcingsPicoSubShelfOceanTempEnum,&Tocs[0],P1DGEnum);
+		this->AddInput(BasalforcingsPicoSubShelfOceanSalinityEnum,&Socs[0],P1DGEnum);
+		this->AddInput(BasalforcingsPicoSubShelfOceanOverturningEnum,&overturnings[0],P1DGEnum);
 
 		/*Cleanup and return*/
@@ -2693,5 +2816,5 @@
 void       Element::PicoComputeBasalMelt(){/*{{{*/
 
-	if(!this->IsIceInElement() || !this->IsFloating()) return;
+	if(!this->IsIceInElement() || !this->IsAllFloating()) return;
 
 	const int NUM_VERTICES = this->GetNumberOfVertices();
@@ -2716,5 +2839,5 @@
 
 	/*Define arrays*/
-	IssmDouble* basalmeltrates_shelf = xNew<IssmDouble>(NUM_VERTICES); //Basal melt-rate
+	IssmDouble basalmeltrates_shelf[MAXVERTICES];
 
 	/*Polynomial coefficients*/
@@ -2789,9 +2912,8 @@
 
 	/*Save computed melt-rate*/
-	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,basalmeltrates_shelf,P1DGEnum);
+	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,&basalmeltrates_shelf[0],P1DGEnum);
 
 	/*Cleanup and return*/
 	delete gauss;
-
 }/*}}}*/
 void       Element::PositiveDegreeDay(IssmDouble* pdds,IssmDouble* pds,IssmDouble signorm,bool ismungsm,bool issetpddfac){/*{{{*/
@@ -3281,5 +3403,4 @@
 	}
 
-
 	/*Assign output pointer*/
 
@@ -3342,6 +3463,4 @@
 				case P1Enum:{
 					const int NUM_VERTICES = this->GetNumberOfVertices();
-
-
 
 					this->GetVerticesSidList(&sidlist[0]);
@@ -3372,4 +3491,59 @@
 
 } /*}}}*/
+void       Element::RignotMeltParameterization(){/*{{{*/
+
+	const int numvertices = this->GetNumberOfVertices();
+   IssmDouble A, B, alpha, beta;
+   IssmDouble bed,qsg,qsg_basin,TF,yts;
+   int numbasins,basinid;
+   IssmDouble* basin_icefront_area=NULL;
+
+   /* Coefficients */
+   A    = 3e-4;
+   B    = 0.15;
+   alpha = 0.39;
+   beta = 1.18;
+
+   /*Get inputs*/
+	this->GetInputValue(&basinid,FrontalForcingsBasinIdEnum);
+	Input* bed_input = this->GetInput(BedEnum);                     _assert_(bed_input);
+   Input* qsg_input = this->GetInput(FrontalForcingsSubglacialDischargeEnum);     _assert_(qsg_input);
+   Input* TF_input  = this->GetInput(FrontalForcingsThermalForcingEnum);          _assert_(TF_input);
+
+	this->FindParam(&yts, ConstantsYtsEnum);
+   this->parameters->FindParam(&numbasins,FrontalForcingsNumberofBasinsEnum);
+   this->parameters->FindParam(&basin_icefront_area,&numbasins,FrontalForcingsBasinIcefrontAreaEnum);
+   IssmDouble meltrates[numvertices];  
+
+   /* Start looping on the number of vertices: */
+   GaussTria gauss;
+   for(int iv=0;iv<numvertices;iv++){
+      gauss.GaussVertex(iv);
+
+      /* Get variables */
+      bed_input->GetInputValue(&bed,&gauss);
+      qsg_input->GetInputValue(&qsg,&gauss);
+      TF_input->GetInputValue(&TF,&gauss);
+
+      if(basin_icefront_area[basinid]==0.) meltrates[iv]=0.;
+      else{
+         /* change the unit of qsg (m^3/d -> m/d) with ice front area */
+         qsg_basin=qsg/basin_icefront_area[basinid];
+
+         /* calculate melt rates */
+         meltrates[iv]=((A*max(-bed,0.)*pow(max(qsg_basin,0.),alpha)+B)*pow(max(TF,0.),beta))/86400; //[m/s]
+      }
+
+      if(xIsNan<IssmDouble>(meltrates[iv])) _error_("NaN found in vector");
+      if(xIsInf<IssmDouble>(meltrates[iv])) _error_("Inf found in vector");
+   }
+
+   /*Add input*/
+   this->AddInput(CalvingMeltingrateEnum,&meltrates[0],P1Enum);
+
+   /*Cleanup and return*/
+   xDelete<IssmDouble>(basin_icefront_area);
+}
+/*}}}*/
 void       Element::SetBoolInput(Inputs* inputs,int enum_in,bool value){/*{{{*/
 
@@ -3407,5 +3581,5 @@
 			switch(set2_enum){
 				case FsetEnum:
-					if(nodes[i]->fsize){
+					if(nodes[i]->FSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -3423,5 +3597,5 @@
 					break;
 				case SsetEnum:
-					if(nodes[i]->ssize){
+					if(nodes[i]->SSize()){
 						if(this->nodes[i]->IsClone())
 						 o_nz += 1;
@@ -3619,4 +3793,5 @@
 	IssmDouble dlw=0.0;
 	IssmDouble dsw=0.0;
+	IssmDouble dswdiff=0.0;
 	IssmDouble P=0.0;
 	IssmDouble eAir=0.0;
@@ -3624,6 +3799,12 @@
 	IssmDouble teValue=1.0;
 	IssmDouble aValue=0.0;
+	IssmDouble dulwrfValue=0.0;
+	IssmDouble szaValue=0.0;
+	IssmDouble cotValue=0.0;
+	IssmDouble ccsnowValue=0.0;
+	IssmDouble cciceValue=0.0;
 	IssmDouble dt,time,smb_dt;
 	int        aIdx=0;
+	int        eIdx=0;
 	int        denIdx=0;
 	int        dsnowIdx=0;
@@ -3635,24 +3816,29 @@
 	IssmDouble initMass=0.0;
    IssmDouble sumR=0.0;
-   IssmDouble sumM=0.0;
+	IssmDouble sumF=0.0;
+	IssmDouble sumM=0.0;
 	IssmDouble sumMsurf=0.0;
-   IssmDouble sumEC=0.0;
-   IssmDouble sumP=0.0;
-   IssmDouble sumW=0.0;
-   IssmDouble sumMassAdd=0.0;
+	IssmDouble sumEC=0.0;
+	IssmDouble sumP=0.0;
+	IssmDouble sumRa=0.0;
+	IssmDouble sumW=0.0;
+	IssmDouble sumMassAdd=0.0;
 	IssmDouble fac=0.0;
 	IssmDouble sumMass=0.0;
 	IssmDouble dMass=0.0;
 	IssmDouble accsumR=0.0;
+	IssmDouble accsumF=0.0;
 	IssmDouble accsumM=0.0;
 	IssmDouble accsumSMB=0.0;
 	IssmDouble accsumEC=0.0;
 	IssmDouble accsumP=0.0;
+	IssmDouble accsumRa=0.0;
 	bool isgraingrowth,isalbedo,isshortwave,isthermal,isaccumulation,ismelt,isdensification,isturbulentflux;
-	bool isclimatology=false;
 	bool isconstrainsurfaceT=false;
+	bool isdeltaLWup=false;
 	IssmDouble init_scaling=0.0;
 	IssmDouble thermo_scaling=1.0;
 	IssmDouble adThresh=1023.0;
+	IssmDouble teThresh=10;
 	/*}}}*/
 	/*Output variables:{{{ */
@@ -3671,4 +3857,5 @@
 	IssmDouble* W = NULL;
 	IssmDouble* a = NULL;
+	IssmDouble* adiff = NULL;
 	IssmDouble* swf=NULL;
 	IssmDouble* T = NULL;
@@ -3677,4 +3864,6 @@
 	IssmDouble  Msurf = 0.0;
 	IssmDouble  R = 0.0;
+	IssmDouble  F = 0.0;
+	IssmDouble  Ra = 0.0;
 	IssmDouble  mAdd = 0.0;
 	IssmDouble  dz_add = 0.0;
@@ -3686,4 +3875,5 @@
 	IssmDouble* Wini = NULL;
 	IssmDouble* aini = NULL;
+	IssmDouble* adiffini = NULL;
 	IssmDouble* Tini = NULL;
 	int         m=0;
@@ -3700,4 +3890,5 @@
 	parameters->FindParam(&smb_dt,SmbDtEnum);                     /*time period for the smb solution,  usually smaller than the glaciological dt*/
 	parameters->FindParam(&aIdx,SmbAIdxEnum);
+	parameters->FindParam(&eIdx,SmbEIdxEnum);
 	parameters->FindParam(&denIdx,SmbDenIdxEnum);
 	parameters->FindParam(&swIdx,SmbSwIdxEnum);
@@ -3716,7 +3907,9 @@
 	parameters->FindParam(&isturbulentflux,SmbIsturbulentfluxEnum);
 	parameters->FindParam(&isconstrainsurfaceT,SmbIsconstrainsurfaceTEnum);
+	parameters->FindParam(&isdeltaLWup,SmbIsdeltaLWupEnum);
 	parameters->FindParam(&init_scaling,SmbInitDensityScalingEnum);
 	parameters->FindParam(&thermo_scaling,SmbThermoDeltaTScalingEnum);
 	parameters->FindParam(&adThresh,SmbAdThreshEnum);
+	parameters->FindParam(&teThresh,SmbTeThreshEnum);
 	/*}}}*/
 	/*Retrieve inputs: {{{*/
@@ -3764,4 +3957,5 @@
 		this->inputs->GetArray(SmbWiniEnum,this->lid,&Wini,&m);
 		this->inputs->GetArray(SmbAiniEnum,this->lid,&aini,&m);
+		this->inputs->GetArray(SmbAdiffiniEnum,this->lid,&adiffini,&m);
 		this->inputs->GetArray(SmbTiniEnum,this->lid,&Tini,&m);
 		EC_input = this->GetInput(SmbECiniEnum);  _assert_(EC_input);
@@ -3783,4 +3977,5 @@
 			W = xNew<IssmDouble>(m); for(int i=0;i<m;i++)W[i]=Wini[0];             //set water content to zero [kg m-2]
 			a = xNew<IssmDouble>(m); for(int i=0;i<m;i++)a[i]=aini[0];         //set albedo equal to fresh snow [fraction]
+			adiff = xNew<IssmDouble>(m); for(int i=0;i<m;i++)adiff[i]=adiffini[0];         //set diffusive albedo equal to 1 [fraction]
 			T = xNew<IssmDouble>(m); for(int i=0;i<m;i++)T[i]=Tmean;         //set initial grid cell temperature to the annual mean temperature [K]
 			/*/!\ Default value of T can not be retrived from SMBgemb.m (like other snow properties)
@@ -3801,4 +3996,5 @@
 			W = xNew<IssmDouble>(m);for(int i=0;i<m;i++)W[i]=Wini[i];
 			a = xNew<IssmDouble>(m);for(int i=0;i<m;i++)a[i]=aini[i];
+			adiff = xNew<IssmDouble>(m);for(int i=0;i<m;i++)adiff[i]=adiffini[i];
 			T = xNew<IssmDouble>(m);for(int i=0;i<m;i++)T[i]=Tini[i];
 
@@ -3812,4 +4008,6 @@
 		this->SetElementInput(SmbAccumulatedMeltEnum,0.0);
 		this->SetElementInput(SmbAccumulatedRunoffEnum,0.0);
+		this->SetElementInput(SmbAccumulatedRefreezeEnum,0.0);
+		this->SetElementInput(SmbAccumulatedRainEnum,0.0);
 		this->SetElementInput(SmbAccumulatedPrecipitationEnum,0.0);
 
@@ -3826,4 +4024,5 @@
 		this->inputs->GetArray(SmbWEnum,this->lid,&W,&m);
 		this->inputs->GetArray(SmbAEnum,this->lid,&a,&m);
+		this->inputs->GetArray(SmbAdiffEnum,this->lid,&adiff,&m);
 		this->inputs->GetArray(SmbTEnum,this->lid,&T,&m);
 		EC_input = this->GetInput(SmbECDtEnum);  _assert_(EC_input);
@@ -3839,5 +4038,5 @@
 
 	// initialize cumulative variables
-	sumR = 0; sumM = 0; sumEC = 0; sumP = 0; sumMassAdd = 0; sumMsurf = 0;
+	sumR = 0; sumF=0; sumM = 0; sumEC = 0; sumP = 0; sumMassAdd = 0; sumMsurf = 0; sumRa = 0;
 
 	//before starting loop, realize that the transient core runs this smb_core at time = time +deltaT.
@@ -3852,4 +4051,6 @@
 		Input *sumM_input          = this->GetInput(SmbMeltEnum);  _assert_(sumM_input);
 		Input *sumR_input          = this->GetInput(SmbRunoffEnum);  _assert_(sumR_input);
+		Input *sumF_input          = this->GetInput(SmbRefreezeEnum);  _assert_(sumF_input);
+		Input *sumRa_input         = this->GetInput(SmbRainEnum);  _assert_(sumRa_input);
 		Input *sumP_input          = this->GetInput(SmbPrecipitationEnum);  _assert_(sumP_input);
 		Input *ULW_input           = this->GetInput(SmbMeanULWEnum);  _assert_(ULW_input);
@@ -3880,4 +4081,8 @@
 		sumR_input->GetInputAverage(&sumR);
 		sumR=sumR*dt*rho_ice;
+		sumF_input->GetInputAverage(&sumF);
+		sumF=sumF*dt*rho_ice;
+		sumRa_input->GetInputAverage(&sumRa);
+		sumRa=sumRa*dt*rho_ice;
 		sumP_input->GetInputAverage(&sumP);
 		sumP=sumP*dt*rho_ice;
@@ -3890,4 +4095,5 @@
 	Input *Dlwr_input= this->GetInput(SmbDlwrfEnum,timeinputs); _assert_(Dlwr_input);
 	Input *Dswr_input= this->GetInput(SmbDswrfEnum,timeinputs); _assert_(Dswr_input);
+	Input *Dswrdiff_input= this->GetInput(SmbDswdiffrfEnum,timeinputs); _assert_(Dswrdiff_input);
 	Input *P_input   = this->GetInput(SmbPEnum,timeinputs);     _assert_(P_input);
 	Input *eAir_input= this->GetInput(SmbEAirEnum,timeinputs);  _assert_(eAir_input);
@@ -3895,4 +4101,9 @@
 	Input *teValue_input= this->GetInput(SmbTeValueEnum,timeinputs); _assert_(teValue_input);
 	Input *aValue_input= this->GetInput(SmbAValueEnum,timeinputs); _assert_(aValue_input);
+	Input *dulwrfValue_input= this->GetInput(SmbDulwrfValueEnum,timeinputs); _assert_(dulwrfValue_input);
+	Input *szaValue_input= this->GetInput(SmbSzaValueEnum,timeinputs); _assert_(szaValue_input);
+	Input *cotValue_input= this->GetInput(SmbCotValueEnum,timeinputs); _assert_(cotValue_input);
+	Input *ccsnowValue_input= this->GetInput(SmbCcsnowValueEnum,timeinputs); _assert_(ccsnowValue_input);
+	Input *cciceValue_input= this->GetInput(SmbCciceValueEnum,timeinputs); _assert_(cciceValue_input);
 
 	/*extract daily data:{{{*/
@@ -3901,9 +4112,15 @@
 	Dlwr_input->GetInputValue(&dlw,gauss);   //downward longwave radiation flux [W m-2]
 	Dswr_input->GetInputValue(&dsw,gauss);   //downward shortwave radiation flux [W m-2]
+	Dswrdiff_input->GetInputValue(&dswdiff,gauss);   //downward shortwave diffuse radiation flux [W m-2]
 	P_input->GetInputValue(&P,gauss);        //precipitation [kg m-2]
 	eAir_input->GetInputValue(&eAir,gauss);  //screen level vapor pressure [Pa]
 	pAir_input->GetInputValue(&pAir,gauss);  // screen level air pressure [Pa]
 	teValue_input->GetInputValue(&teValue,gauss);  // Emissivity [0-1]
+	dulwrfValue_input->GetInputValue(&dulwrfValue,gauss);  // LWup perturbation [W m-2]
 	aValue_input->GetInputValue(&aValue,gauss);  // Albedo [0 1]
+	szaValue_input->GetInputValue(&szaValue,gauss);  // Solar Zenith Angle [degree]
+	cotValue_input->GetInputValue(&cotValue,gauss);  // Cloud Optical Thickness
+	ccsnowValue_input->GetInputValue(&ccsnowValue,gauss); //concentration of light absorbing carbon for snow [ppm1]
+	cciceValue_input->GetInputValue(&cciceValue,gauss); //concentration of light absorbing carbon for ice [ppm1]
 	//_printf_("Time: " << t << " Ta: " << Ta << " V: " << V << " dlw: " << dlw << " dsw: " << dsw << " P: " << P << " eAir: " << eAir << " pAir: " << pAir << "\n");
 	/*}}}*/
@@ -3913,8 +4130,8 @@
 
 	/*Snow, firn and ice albedo:*/
-	if(isalbedo)albedo(&a,aIdx,re,dz,d,cldFrac,aIce,aSnow,aValue,adThresh,T,W,P,EC,Msurf,t0wet,t0dry,K,smb_dt,rho_ice,m,this->Sid());
+	if(isalbedo)albedo(&a,&adiff,aIdx,re,dz,d,cldFrac,aIce,aSnow,aValue,adThresh,T,W,P,EC,Msurf,ccsnowValue,cciceValue,szaValue,cotValue,t0wet,t0dry,K,smb_dt,rho_ice,m,this->Sid());
 
 	/*Distribution of absorbed short wave radation with depth:*/
-	if(isshortwave)shortwave(&swf, swIdx, aIdx, dsw, a[0], d, dz, re,rho_ice,m,this->Sid());
+	if(isshortwave)shortwave(&swf, swIdx, aIdx, dsw, dswdiff, a[0], adiff[0], d, dz, re,rho_ice,m,this->Sid());
 
 	/*Calculate net shortwave [W m-2]*/
@@ -3926,5 +4143,5 @@
 	}
 	/*Thermal profile computation:*/
-	if(isthermal)thermo(&EC, &T, &ulw, dz, d, swf, dlw, Ta, V, eAir, pAir, teValue, W[0], smb_dt, m, Vz, Tz, thermo_scaling,rho_ice,this->Sid(),isconstrainsurfaceT);
+	if(isthermal)thermo(&EC, &T, &ulw, re, dz, d, swf, dlw, Ta, V, eAir, pAir, eIdx, teValue, dulwrfValue, teThresh, W[0], smb_dt, m, Vz, Tz, thermo_scaling,rho_ice,this->Sid(),isconstrainsurfaceT,isdeltaLWup);
 
 	/*Change in thickness of top cell due to evaporation/condensation  assuming same density as top cell.
@@ -3933,9 +4150,9 @@
 
 	/*Add snow/rain to top grid cell adjusting cell depth, temperature and density*/
-	if(isaccumulation)accumulation(&T, &dz, &d, &W, &a, &re, &gdn, &gsp, &m, aIdx, dsnowIdx, Tmean, Ta, P, dzMin, aSnow, C, V, Vmean, rho_ice,this->Sid());
+	if(isaccumulation)accumulation(&T, &dz, &d, &W, &a, &adiff, &re, &gdn, &gsp, &Ra, &m, aIdx, dsnowIdx, Tmean, Ta, P, dzMin, aSnow, C, V, Vmean, rho_ice,this->Sid());
 
 	/*Calculate water production, M [kg m-2] resulting from snow/ice temperature exceeding 273.15 deg K
 	 * (> 0 deg C), runoff R [kg m-2] and resulting changes in density and determine wet compaction [m]*/
-	if(ismelt)melt(&M, &Msurf, &R, &mAdd, &dz_add, &T, &d, &dz, &W, &a, &re, &gdn, &gsp, &m, dzMin, zMax, zMin, zTop, zY, rho_ice,this->Sid());
+	if(ismelt)melt(&M, &Msurf, &R, &F, &mAdd, &dz_add, &T, &d, &dz, &W, &a, &adiff, &re, &gdn, &gsp, &m, Ra, dzMin, zMax, zMin, zTop, zY, rho_ice,this->Sid());
 
 	/*Allow non-melt densification and determine compaction [m]*/
@@ -3967,4 +4184,5 @@
 					<< "lwf[" << netLW << "] "
 					<< "a[" << a << "] "
+					<< "adiff[" << adiff << "] "
 					<< "te[" << teValue << "] "
 					<< "\n");
@@ -3981,5 +4199,7 @@
 	sumW = cellsum(W,m);
 	sumP = P +  sumP;
-	sumEC = sumEC + EC;  // evap (-)/cond(+)
+	sumEC = EC + sumEC;  // evap (-)/cond(+)
+	sumRa = Ra + sumRa;
+	sumF = F + sumF;
 
 	/*Calculate total system mass:*/
@@ -4000,5 +4220,6 @@
 	/*Check mass conservation:*/
 	if (dMass != 0.0){
-		_printf_("total system mass not conserved in MB function \n");
+		_printf_("Time: " << setprecision(8) << timeinputs/365.0/24.0/3600.0 << ",total system mass not conserved in MB function \n");
+		_printf_("sumMass: " << sumMass << " sumR: " << sumR << " sumW: " << sumW << " sumP: " << sumP << " sumEC: " << sumEC << " initMass: " << initMass << " sumMassAdd: " << sumMassAdd << " \n");
 	}
 	#endif
@@ -4012,13 +4233,17 @@
    Input *accsumEC_input         = this->GetInput(SmbAccumulatedECEnum);  _assert_(accsumEC_input);
    Input *accsumM_input          = this->GetInput(SmbAccumulatedMeltEnum);  _assert_(accsumM_input);
-   Input *accsumR_input          = this->GetInput(SmbAccumulatedRunoffEnum);  _assert_(accsumR_input);
-   Input *accsumP_input          = this->GetInput(SmbAccumulatedPrecipitationEnum);  _assert_(accsumP_input);
-   Input *accsumSMB_input        = this->GetInput(SmbAccumulatedMassBalanceEnum);  _assert_(accsumP_input);
+	Input *accsumR_input          = this->GetInput(SmbAccumulatedRunoffEnum);  _assert_(accsumR_input);
+	Input *accsumF_input          = this->GetInput(SmbAccumulatedRefreezeEnum);  _assert_(accsumF_input);
+	Input *accsumRa_input         = this->GetInput(SmbAccumulatedRainEnum);  _assert_(accsumRa_input);
+	Input *accsumP_input          = this->GetInput(SmbAccumulatedPrecipitationEnum);  _assert_(accsumP_input);
+	Input *accsumSMB_input        = this->GetInput(SmbAccumulatedMassBalanceEnum);  _assert_(accsumSMB_input);
 
    accsumEC_input->GetInputAverage(&accsumEC);
-   accsumM_input->GetInputAverage(&accsumM);
-   accsumR_input->GetInputAverage(&accsumR);
-   accsumP_input->GetInputAverage(&accsumP);
-   accsumSMB_input->GetInputAverage(&accsumSMB);
+	accsumM_input->GetInputAverage(&accsumM);
+	accsumR_input->GetInputAverage(&accsumR);
+	accsumF_input->GetInputAverage(&accsumF);
+	accsumRa_input->GetInputAverage(&accsumRa);
+	accsumP_input->GetInputAverage(&accsumP);
+	accsumSMB_input->GetInputAverage(&accsumSMB);
 
 	this->SetElementInput(SmbAccumulatedECEnum,accsumEC+EC/rho_ice);
@@ -4026,4 +4251,6 @@
 	this->SetElementInput(SmbAccumulatedMeltEnum,accsumM+M/rho_ice);
 	this->SetElementInput(SmbAccumulatedRunoffEnum,accsumR+R/rho_ice);
+	this->SetElementInput(SmbAccumulatedRefreezeEnum,accsumF+F/rho_ice);
+	this->SetElementInput(SmbAccumulatedRainEnum,accsumRa+Ra/rho_ice);
 	this->SetElementInput(SmbAccumulatedPrecipitationEnum,accsumP+P/rho_ice);
    /*}}}*/
@@ -4038,8 +4265,11 @@
 	this->inputs->SetArrayInput(SmbWEnum,this->lid,W,m);
 	this->inputs->SetArrayInput(SmbAEnum,this->lid,a,m);
+	this->inputs->SetArrayInput(SmbAdiffEnum,this->lid,adiff,m);
 	this->SetElementInput(SmbECEnum,sumEC/dt/rho_ice);
 	this->SetElementInput(SmbMassBalanceEnum,(sumP + sumEC -sumR)/dt/rho_ice);
 	this->SetElementInput(SmbMeltEnum,sumM/dt/rho_ice);
 	this->SetElementInput(SmbRunoffEnum,sumR/dt/rho_ice);
+	this->SetElementInput(SmbRefreezeEnum,sumF/dt/rho_ice);
+	this->SetElementInput(SmbRainEnum,sumRa/dt/rho_ice);
 	this->SetElementInput(SmbPrecipitationEnum,sumP/dt/rho_ice);
 	this->SetElementInput(SmbMeanULWEnum,meanULW);
@@ -4064,4 +4294,5 @@
 	if(W) xDelete<IssmDouble>(W);
 	if(a) xDelete<IssmDouble>(a);
+	if(adiff) xDelete<IssmDouble>(adiff);
 	if(T) xDelete<IssmDouble>(T);
 	if(dzini) xDelete<IssmDouble>(dzini);
@@ -4072,4 +4303,5 @@
 	if(Wini) xDelete<IssmDouble>(Wini);
 	if(aini) xDelete<IssmDouble>(aini);
+	if(adiffini) xDelete<IssmDouble>(adiffini);
 	if(Tini) xDelete<IssmDouble>(Tini);
 	if(swf) xDelete<IssmDouble>(swf);
@@ -4182,4 +4414,49 @@
 
 }/*}}}*/
+void       Element::StrainRateMLHO(IssmDouble* epsilon,IssmDouble* xyz_list,Gauss* gauss,Input* vxbase_input,Input* vybase_input,Input* vxshear_input,Input* vyshear_input,Input* thickness_input,Input* n_input,IssmDouble zeta){/*{{{*/
+	/*Compute the 2d Blatter/MLHO Strain Rate (5 components) for a given vertical coordinate (zeta):
+	 *
+	 * epsilon=[exx eyy exy exz eyz]
+	 *
+	 * with exz=1/2 du/dz
+	 *      eyz=1/2 dv/dz
+	 *
+	 * the contribution of vz is neglected
+	 *
+	 * zeta = (surface - z)/thickness 
+	 * i.e., zeta=0 <=> ice surface
+	 * i.e., zeta=1 <=> ice base
+	 */
+
+	/*Intermediaries*/
+	IssmDouble dvxb[2];  // [dvx/dx, dvx/dy] at the base
+	IssmDouble dvyb[2];  // [dvy/dx, dvy/dy] at the base
+	IssmDouble dvxsh[2]; // [dvx/dx, dvx/dy] at the surface (only the shear)
+	IssmDouble dvysh[2]; // [dvy/dx, dvy/dy] at the surface (only the shear)
+	IssmDouble vxsh,vysh; // shear vx and shear at the surface
+	IssmDouble thickness,n;
+
+	/*Check that both inputs have been found*/
+	if (!vxbase_input || !vybase_input || !vxshear_input || !vyshear_input || !thickness_input || !n_input){
+		_error_("Input missing. Here are the input pointers we have for vxb: " << vxbase_input << ", vyb: " << vybase_input << ", vxshear: " << vxshear_input << ", vyshear: " << vyshear_input << ", thickness: " << thickness_input << ", n: " << n_input<< "\n");
+	}
+
+	/*Get strain rate assuming that epsilon has been allocated*/
+	vxbase_input->GetInputDerivativeValue(&dvxb[0],xyz_list,gauss);
+	vybase_input->GetInputDerivativeValue(&dvyb[0],xyz_list,gauss);
+	vxshear_input->GetInputDerivativeValue(&dvxsh[0],xyz_list,gauss);
+	vyshear_input->GetInputDerivativeValue(&dvysh[0],xyz_list,gauss);
+	thickness_input->GetInputValue(&thickness,gauss); _assert_(thickness>0);
+   vxshear_input->GetInputValue(&vxsh,gauss);
+   vyshear_input->GetInputValue(&vysh,gauss);
+   n_input->GetInputValue(&n,gauss);
+
+	epsilon[0] = dvxb[0] + dvxsh[0]*( 1 - pow(zeta,n+1) );
+	epsilon[1] = dvyb[1] + dvysh[1]*( 1 - pow(zeta,n+1) );
+	epsilon[2] = 0.5*( dvxb[1] + dvxsh[1]*( 1 - pow(zeta,n+1) ) + dvyb[0] + dvysh[0]*( 1 - pow(zeta,n+1) ) ); 
+	epsilon[3] = 0.5*(vxsh/thickness)*(n+1)*pow(zeta,n);
+	epsilon[4] = 0.5*(vysh/thickness)*(n+1)*pow(zeta,n);
+
+}/*}}}*/
 void       Element::StrainRateSSA(IssmDouble* epsilon,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){/*{{{*/
 
@@ -4232,6 +4509,5 @@
 	/*Fetch number vertices and allocate memory*/
 	const int NUM_VERTICES  = this->GetNumberOfVertices();
-
-	IssmDouble* maxprincipal = xNew<IssmDouble>(NUM_VERTICES);
+	IssmDouble maxprincipal[MAXVERTICES];
 
 	/*Retrieve all inputs and parameters*/
@@ -4251,5 +4527,5 @@
 	/*loop over vertices: */
 	Gauss* gauss=this->NewGauss();
-	for (int iv=0;iv<NUM_VERTICES;iv++){
+	for(int iv=0;iv<NUM_VERTICES;iv++){
 		gauss->GaussVertex(iv);
 
@@ -4296,8 +4572,7 @@
 
 	/*Create input*/
-	this->AddInput(StressMaxPrincipalEnum,maxprincipal,P1Enum);
+	this->AddInput(StressMaxPrincipalEnum,&maxprincipal[0],P1Enum);
 
 	/*Clean up and return*/
-	xDelete<IssmDouble>(maxprincipal);
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
@@ -4374,6 +4649,6 @@
 
 	/*Copy current stiffness matrix*/
-	values=xNew<IssmDouble>(Ke->nrows*Ke->ncols);
-	for(i=0;i<Ke->nrows;i++) for(j=0;j<Ke->ncols;j++) values[i*Ke->ncols+j]=Ke->values[i*Ke->ncols+j];
+	values=xNew<IssmDouble>(Ke->nrows*Ke->nrows);
+	for(i=0;i<Ke->nrows;i++) for(j=0;j<Ke->nrows;j++) values[i*Ke->nrows+j]=Ke->values[i*Ke->nrows+j];
 
 	/*Get Coordinate Systems transform matrix*/
@@ -4382,5 +4657,5 @@
 	/*Transform matrix: R*Ke*R^T */
 	TripleMultiply(transform,numdofs,numdofs,0,
-				values,Ke->nrows,Ke->ncols,0,
+				values,Ke->nrows,Ke->nrows,0,
 				transform,numdofs,numdofs,1,
 				&Ke->values[0],0);
@@ -4550,6 +4825,6 @@
 
 	/*Copy current stiffness matrix*/
-	values=xNew<IssmDouble>(Ke->nrows*Ke->ncols);
-	for(int i=0;i<Ke->nrows*Ke->ncols;i++) values[i]=Ke->values[i];
+	values=xNew<IssmDouble>(Ke->nrows*Ke->nrows);
+	for(int i=0;i<Ke->nrows*Ke->nrows;i++) values[i]=Ke->values[i];
 
 	/*Get Coordinate Systems transform matrix*/
@@ -4558,5 +4833,5 @@
 	/*Transform matrix: R^T*Ke*R */
 	TripleMultiply(transform,numdofs,numdofs,1,
-				values,Ke->nrows,Ke->ncols,0,
+				values,Ke->nrows,Ke->nrows,0,
 				transform,numdofs,numdofs,0,
 				&Ke->values[0],0);
@@ -4575,6 +4850,5 @@
 	/*Fetch number vertices and allocate memory*/
 	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	IssmDouble* viscousheating = xNew<IssmDouble>(NUM_VERTICES);
+	IssmDouble viscousheating[MAXVERTICES];
 
 	/*Retrieve all inputs and parameters*/
@@ -4595,8 +4869,7 @@
 
 	/*Create PentaVertex input, which will hold the basal friction:*/
-	this->AddInput(ViscousHeatingEnum,viscousheating,P1Enum);
+	this->AddInput(ViscousHeatingEnum,&viscousheating[0],P1Enum);
 
 	/*Clean up and return*/
-	xDelete<IssmDouble>(viscousheating);
 	xDelete<IssmDouble>(xyz_list);
 	delete gauss;
@@ -4683,6 +4956,6 @@
 	IssmDouble  kappa,kappa_c,kappa_t;  //enthalpy conductivities
 	IssmDouble  Hc,Ht;
-	IssmDouble* PIE   = xNew<IssmDouble>(numvertices);
-	IssmDouble* dHpmp = xNew<IssmDouble>(numvertices);
+	IssmDouble PIE[MAXVERTICES];
+	IssmDouble dHpmp[MAXVERTICES];
 
 	for(int iv=0; iv<numvertices; iv++){
@@ -4720,6 +4993,4 @@
 
 	/*Clean up and return*/
-	xDelete<IssmDouble>(PIE);
-	xDelete<IssmDouble>(dHpmp);
 	return kappa;
 }
